<?php
namespace Ak\Container;

use Psr\Container\ContainerInterface;

/**
 * Trait ContainerAwareTrait
 *
 * @package Ak\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/container
 */
trait ContainerAwareTrait
{
    /** @var ContainerInterface */
    protected $container;

    /**
     * @return ContainerInterface
     */
    public function getContainer(): ContainerInterface
    {
        if (null === $this->container) {
            $this->setContainer((new ContainerFactory())([]));
        }

        return $this->container;
    }

    /**
     * @param ContainerInterface $container
     */
    public function setContainer(ContainerInterface $container): void
    {
        $this->container = $container;
    }
}